# GNUmakefile.self: let tesla build tesla

UNIT=		tesla
UNIT_DIR=	../tesla

INCLUDE_DIRS=	.. ../.. ../../gp ../../tom

READABLE=	-freadable-c

LIBS=		-lm -lpthread -ldl
CFLAGS=		-w
ALL_CFLAGS=	-pipe -g -O -I . $(CFLAGS) $(patsubst %, -I %, $(INCLUDE_DIRS))

TOM_SRC=	Argument.t Assignment.t C.t Compound.t Expression.t Extension.t Invocation.t Meta.t Method.t Selector.t Special.t TomFile.t Type.t Unit.t Variable.t extensions.t tesla.t tom.t various.t config.t

TOM_GEN=	$(TOM_SRC:.t=.c) $(UNIT)-r.c
OBJ=		$(TOM_SRC:.t=.o) $(UNIT)-r.o

%.o: %.c
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

all: alset

force: clean alset
force-self: clean alself

alset: $(OBJ)
	time gcc $(OBJ) -o $@ ../../mu/.libs/libmu.a ../../gp/gps/.libs/libgps.a ../../tom/C/.libs/libC.a ../../tom/tom/.libs/libtom.a ../../tom/trt/.libs/libtrt.a $(LIBS)

alself: $(OBJ)
	time gcc $(OBJ) -o $@ ../unit/mu/libmu.a ../unit/gps/libgps.a ../unit/C/libC.a ../unit/tom/libtom.a ../../tom/trt/.libs/libtrt.a  ../unit/_builtin_/lib_builtin_.a $(LIBS)

$(TOM_GEN): .stamp-prepare

.stamp-prepare: $(patsubst %,$(UNIT_DIR)/%, $(TOM_SRC))
	time $(TESLA) :cc-pre :cc-post -1 $(READABLE) -u $(UNIT) -I $(UNIT_DIR) $(patsubst %, -I %, $(INCLUDE_DIRS)) :gc-stat :gc-pth 75000
	touch $@

clean:
	$(RM) $(TOM_GEN) $(OBJ) $(UNIT)-r.h alset alself .stamp-prepare
