<copyright> TESLA mu.Argument extensions.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of TESLA.  TESLA is distributed under the terms of
    the GNU General Public License, a copy of which can be found in the
    TESLA distribution; see the file COPYING.

    <id>$Id: Argument.t,v 1.5 1998/05/26 14:52:25 tiggr Exp $</id>
    </copyright>

implementation class
Argument extension tesla: tesla

end;

implementation instance
Argument extension tesla

<doc> Resolve the {default_value} of this argument, if it has one.  </doc>
void
  resolveDefaultValue Meta context_type
{
  if (default_value != nil)
    default_value = [default_value resolve (nil, nil) context context_type];
}

deferred OutputStream
  writeCDeclaration OutputStream s
	     prefix String prefix;

end;

/******************** ArgumentSingle ********************/

implementation class
ArgumentSingle extension tesla

end;

implementation instance
ArgumentSingle extension tesla

<doc> Do nothing for this argument.  </doc>
id
  initializeNonArgumentReturnValues Compound parent
{
  = self;
}

OutputStream (s)
  writeCDeclaration OutputStream s
	     prefix String prefix
{
  [self writeCName [[type writeCType [s print prefix]] print ' ']];
}

end;

/******************** ArgumentTuple ********************/

implementation class
ArgumentTuple extension tesla: tesla

<doc> Return an argument tuple containing the variables in the
    {VariableTuple}.  </doc>
instance (id) (at)
  withVariableTuple VariableTuple vt
{
  int i, n = [vt length];
  at = [[self alloc vt] initWithCapacity n];

  // This only works for flat tuples.
  // Mon Apr 27 12:01:35 1998, tiggr@gerbil.org
  for (i = 0; i < n; i++)
    [at add Variable (vt[i])];
}

end;

implementation instance
ArgumentTuple extension tesla

<doc> Pass to the elements.  </doc>
Argument
  initializeNonArgumentReturnValues Compound parent
{
  int i;
  for (i = 0; i < length; i++)
    {
      ArgumentSingle a = self[i];
      Argument b = [a initializeNonArgumentReturnValues parent];
      if (a != b)
	self[i] = b;
    }
  = self;
}

<doc> Pass to the elements.  </doc>
OutputStream (s)
  writeCDeclaration OutputStream s
	     prefix String prefix
{
  int i;
  for (i = 0; i < length; i++)
    [self[i] writeCDeclaration s prefix prefix];
}

end;
